//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
ReadThread *port_reader;
WriteThread *port_writer;
//---------------------------------------------------------------------------
void OpenPort()
{ dcb.DCBlength=sizeof(DCB);
  //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  Port=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port==INVALID_HANDLE_VALUE)
  { MessageBox(NULL,"  ","Error",MB_OK);
    return;
  }
  else
  { if(GetCommState(Port,&dcb)==0)
    { MessageBox(NULL,"   ","Error",MB_OK);
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }
    else
    { dcb.BaudRate=115200;
      dcb.ByteSize=8;
      dcb.Parity=0;
      dcb.StopBits=2;
      dcb.fBinary=true;          //  
      dcb.fOutxCtsFlow=false;    //  CTS
      dcb.fOutxDsrFlow=false;    //  DSR
      dcb.fDtrControl=DTR_CONTROL_DISABLE;     // DTR
      dcb.fDsrSensitivity=false;               //  DSR
      dcb.fNull=false;           //  
      dcb.fRtsControl=RTS_CONTROL_DISABLE;    // RTS
      dcb.fAbortOnError=false;   //  /  
   }
   if(SetCommState(Port,&dcb)==0)
   { MessageBox(NULL,"   ","Error",MB_OK);
     CloseHandle(Port);
     Port=INVALID_HANDLE_VALUE;
     return;
   }

   memset(wr_buf,0,BUFSIZE);        //    
   wr_buf_len=0;                    //  
   SetupComm(Port,BUFSIZE+100,BUFSIZE+100);       //    
   PurgeComm(Port,PURGE_RXCLEAR|PURGE_TXCLEAR);   //     

   Form1->Button2->Enabled=false;
   Form1->Button3->Enabled=true;
   WR_FLAG=false;
   RD_FLAG=false;

   port_reader=new ReadThread(false);  //    
   port_reader->FreeOnTerminate=false; //     
   port_writer=new WriteThread(true);  //      
   port_writer->FreeOnTerminate=false; //     
  }
}
//---------------------------------------------------------------------------
void ClosePort()
{ Form1->Timer1->Enabled=false;
  TimerStep=0;
  if(port_writer)
  { port_writer->Terminate(); //    -  
    SetEvent(ovr_wr.hEvent);  //  ,      (WaitForSingleObject    INFINITE)
    port_writer->Resume();    // ,    
    port_writer->WaitFor();
  }

  if(port_reader)
  { port_reader->Terminate(); //    -  
    SetEvent(ovr_rd.hEvent);  //  ,      (WaitForSingleObject    INFINITE)
    port_reader->Resume();    // ,    
    port_reader->WaitFor();
  }

  CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  Form1->Button2->Enabled=true;
  Form1->Button3->Enabled=false;
}
//--------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall ReadThread::ReadThread(bool CreateSuspended) // 
     : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall ReadThread::Execute()
{COMSTAT    port_status;
 DWORD      temp, mask;

 ovr_rd.hEvent=CreateEvent(NULL, true, true, NULL); // 
 SetCommMask(Port, EV_RXCHAR);                      //     
 while(!Terminated)                      //     -  
  { WaitCommEvent(Port,&mask,&ovr_rd);   //   
    WaitForSingleObject(ovr_rd.hEvent,INFINITE); //   1    
    if(GetOverlappedResult(Port,&ovr_rd,&temp,true)) //     WaitCommEvent (  false -   ,  true - )
     { if((mask&EV_RXCHAR)!=0)           //     
        { ClearCommError(Port,&temp,&port_status);    //  port_status
          rd_buf_len=0;
          rd_buf_len=port_status.cbInQue;  //-  
          if(rd_buf_len)
           { ReadFile(Port,rd_buf,rd_buf_len,&temp,&ovr_rd); //  - 
             Synchronize(PlaceReadedOnForm);
           }
        }
     }
  }
 CloseHandle(ovr_rd.hEvent); // -
 ReturnValue=0;              // 0  
}
//---------------------------------------------------------------------------
void __fastcall ReadThread::PlaceReadedOnForm()
{ int buflen, i,j;
  char buf[BUFSIZE], hexbuf[3*BUFSIZE];
  AnsiString tempch, tempstr;

  memset(buf,0,BUFSIZE);      //  
  memset(hexbuf,0,3*BUFSIZE); //   hex
  buflen=rd_buf_len;
  memcpy(buf,rd_buf,buflen);  //    

  for(int i=0;i<buflen;i++)
  { tempch=IntToHex(buf[i],2);
    j=tempch.Length();
    tempch.Delete(1,j-2);     //      FFFF FFXX

    strcat(hexbuf,tempch.c_str());
  }
  strcat(out_buf,hexbuf);     //      
  RD_FLAG=true;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall WriteThread::WriteThread(bool CreateSuspended) // 
     : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall WriteThread::Execute()
{ DWORD      temp;

  ovr_wr.hEvent=CreateEvent(NULL,true,true,NULL);       // 
  while(!Terminated)
  { if(wr_buf_len!=0)                                   //  ,   - 
    { WriteFile(Port,wr_buf,wr_buf_len,&temp,&ovr_wr);  //   
      WaitForSingleObject(ovr_wr.hEvent,INFINITE);      //   1         
      if(GetOverlappedResult(Port,&ovr_wr,&temp,true))
           WR_FLAG=true;
      else WR_FLAG=false;              //    -  ,   - 
      Synchronize(ShowResultMessage);  // ,  ,  
      port_writer->Suspend();          //  
    }
  }
  CloseHandle(ovr_wr.hEvent); //    -  
  ReturnValue=0;              // 0  
}
//---------------------------------------------------------------------------
void __fastcall WriteThread::ShowResultMessage()
{ if(!WR_FLAG)
  { Form1->Timer1->Enabled=false;
    RD_FLAG=true;
    WR_FLAG=true;
    MessageBox(NULL,"  ","Error",MB_OK);
  }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Port=INVALID_HANDLE_VALUE;
  Form1->AutoSize=true;
  Form1->Button2->Enabled=true;
  Form1->Button3->Enabled=false;
  TimerStep=0;
  Timer1->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ //    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ //     
  if(Port==INVALID_HANDLE_VALUE)
   { OpenPort();
     if(Port!=INVALID_HANDLE_VALUE)
      { wr_buf_len=3;
        wr_buf[0]=0x0A;  //  
        wr_buf[1]=0x08;  //  
        wr_buf[2]=0x03;  //   1W
        port_writer->Resume();
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ //  
  if(Port!=INVALID_HANDLE_VALUE)
   { Timer1->Enabled=false;
     ClosePort();
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ //         ,    
  if(Port!=INVALID_HANDLE_VALUE)
  { if(WR_FLAG&RD_FLAG)   //     -  
    { TimerStep=TimerStep+1;  //  
      if(TimerStep>10) TimerStep=1;
      switch(TimerStep)
       { case 1: wr_buf_len=1;
                 wr_buf[0]=0x60;  // 
                 WR_FLAG=false;
                 RD_FLAG=true;
                 Edit2->Text="R";
                 Edit1->Text=out_buf;        // ,     
                 memset(out_buf,0,BUFSIZE);  //     
                 port_writer->Resume();
                 break;
         case 2: wr_buf_len=2;
                 wr_buf[0]=0x61;  //  
                 if(RadioButton1->Checked==true)  wr_buf[1]=0x33;  //     0x33
                 else                             wr_buf[1]=0x0F;  //     0x0F
                 WR_FLAG=false;
                 RD_FLAG=true;
                 if(RadioButton1->Checked==true)  Edit2->Text="33";
                 else                             Edit2->Text="0F";
                 port_writer->Resume();
                 break;
         case 3: wr_buf_len=1;
                 wr_buf[0]=0x62;  //   1
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="1";
                 port_writer->Resume();
                 break;
         case 4: strcat(out_buf," ");
                 wr_buf_len=1;
                 wr_buf[0]=0x62;  //   2
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="2";
                 port_writer->Resume();
                 break;
         case 5: strcat(out_buf," ");
                 wr_buf_len=1;
                 wr_buf[0]=0x62;  //   3
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="3";
                 port_writer->Resume();
                 break;
         case 6: strcat(out_buf," ");
                 wr_buf_len=1;
                 wr_buf[0]=0x62;  //   4
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="4";
                 port_writer->Resume();
                 break;
         case 7: strcat(out_buf," ");
                 wr_buf_len=1;
                 wr_buf[0]=0x62;  //   5
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="5";
                 port_writer->Resume();
                 break;
         case 8: strcat(out_buf," ");
                 wr_buf_len=1;
                 wr_buf[0]=0x62;  //   6
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="6";
                 port_writer->Resume();
                 break;
         case 9: strcat(out_buf," ");
                 wr_buf_len=1;
                 wr_buf[0]=0x62;  //   7
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="7";
                 port_writer->Resume();
                 break;
         case 10:strcat(out_buf," ");
                 wr_buf_len=1;
                 wr_buf[0]=0x62;  //   8
                 WR_FLAG=false;
                 RD_FLAG=false;
                 Edit2->Text="8";
                 port_writer->Resume();
                 break;
         default:break;
       }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ //   -  
  if(Timer1->Enabled==false)
   { TimerStep=0;
     WR_FLAG=true;
     RD_FLAG=true;
     memset(out_buf,0,BUFSIZE);  //     
     Timer1->Enabled=true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------

